	implicit none
	integer i,n,nsz,err
	real*8 a,dauer,dt
	real*8 radial(3),tangent(3),kreuz(3)
	real s(2000)
	real z(2000)
	real*8 m(9,10)
	open (unit=1,file='ballist.dat',status='OLD',err=1)
	goto 2
1	continue
	close (unit=1)
	call beispiel ()
2	continue
	read (1,*)
	read (1,*) (radial(i),i=1,3)
	read (1,*)
	read (1,*) (tangent(i),i=1,3)
	read (1,*)
	read (1,*) n,nsz
*	write(*,*) ' Anzahl=',n,nsz
	close (unit=1)
*	write(*,*)
*     +	radial(1)*tangent(1)+radial(2)*tangent(2)+radial(3)*tangent(3)
	if(n.gt.9) stop ' mehr als 9 Krper'
	if(nsz.gt.2000) stop ' mehr als 2000 Punkte'
	a=0.
	do i=1,3
	a=a+radial(i)**2
	end do
	if(a.eq.0.) stop ' Radial singulr'
	a=dsqrt(a)
	do i=1,3
	radial(i)=radial(i)/a
	end do
	a=0.
	do i=1,3
	a=a+tangent(i)**2
	end do
	if(a.eq.0.) stop ' Tangential singulr'
	a=dsqrt(a)
	do i=1,3
	tangent(i)=tangent(i)/a
	end do
*	write(*,*)
*     +	radial(1)*tangent(1)+radial(2)*tangent(2)+radial(3)*tangent(3)
	a=0.
	do i=1,3
	a=a+radial(i)*tangent(i)
	end do
*	write(*,*) a,'<',1.e-6
	if(a.gt.1.d-6) stop ' Radial und Tangential nicht Orthogonal'
*	r1		r2		r3
*	t1		t2		t3
*	r2*t3-r3*t2	r3*t1-r1*t3	r1*t2-r2*t1
	kreuz(1)=radial(2)*tangent(3)-radial(3)*tangent(2)
	kreuz(2)=radial(3)*tangent(1)-radial(1)*tangent(3)
	kreuz(3)=radial(1)*tangent(2)-radial(2)*tangent(1)
	a=0.
	do i=1,3
	a=a+kreuz(i)**2
	end do
	if(a.eq.0.) stop ' Kreuz singulr'
	a=dsqrt(a)
	do i=1,3
	kreuz(i)=kreuz(i)/a
	end do
	call eingabe(n,dauer,dt,a,m,nsz)
	call magnitud(dauer,nsz,s)
	call berechne(n,dauer,dt,a,m,nsz,s,z,
     +		radial,tangent,kreuz)
	end
	subroutine vglpv (n,k,p,v,p0,v0)
	implicit none
	character*1 ink
	logical logi
	integer i,j,n,k
	real*8 p(9,3),v(9,3),p0(9,3),v0(9,3),pw,vw,eps
	common/relfehl/eps
	logi=.false.
	write(*,*) ' Startwerte hinreichend genau erreicht? ',eps
	do i=1,n
	pw=0.
	vw=0.
	do j=1,k
	pw=pw+p0(i,j)**2
	vw=vw+v0(i,j)**2
	end do
	pw=max(dsqrt(pw),1.d0)
	vw=max(dsqrt(vw),1.d0)
	do j=1,k
	if(dabs(p0(i,j)-p(i,j)).gt.pw*eps) then
		if(.not.logi) write(*,*) '          Start   <>  aktuell'
		logi=.true.
		write(*,'('' x '',2i3,'' '',f8.5,'' <> '',f8.5)')
     +			i,j,p0(i,j)/pw,p(i,j)/pw
	end if
	if(dabs(v0(i,j)-v(i,j)).gt.vw*eps) then
		if(.not.logi) write(*,*) '          Start   <>  aktuell'
		logi=.true.
		write(*,'('' v '',2i3,'' '',f8.5,'' <> '',f8.5)')
     +			i,j,v0(i,j)/vw,v(i,j)/vw
	end if
	end do
	end do
	if(logi) then
		write(*,*) 
     +	' dt zu gro fr brauchbares Resultat	Taste ( x => Stop )'
		read (*,'(a1)') ink
		if(ink.eq.'x') Stop
	end if
	return
	end
	subroutine inivgl(n,k,p,v,p0,v0)
	implicit none
	integer i,j,n,k
	real*8 p(9,3),v(9,3),p0(9,3),v0(9,3),eps
	common/relfehl/eps
	data eps/.001/
	call fehler(eps)
	do i=1,n
	 do j=1,k
	  p0(i,j)=p(i,j)
	  v0(i,j)=v(i,j)
	 end do
	end do
	return
	end
	subroutine fehler(eps)
	implicit none
	real*8 eps
	open (unit=1,file='fehler',status='OLD',err=1)
	read (1,*) eps
	if(1.d-5.gt.eps.or.eps.gt.1.d-1) then
		write(*,*) ' es mu gelten .00001 <= fehler <= .1'
		stop ' datei fehler korrigieren!' 
	end if
	close (unit=1)
	return
1	continue
	open (unit=1,file='fehler',status='NEW')
	write(1,'('' '',f7.5)') eps
	close (unit=1)
	return
	end
	subroutine ausdrck(n,k,b,p,v,dt)
	implicit none
	integer n,k,i
	real*8 b(9,3),p(9,3),v(9,3),dt
	do i=1,3
	 v(k,i)=v(k,i)+dt*b(k,i)
	 p(k,i)=p(k,i)+dt*v(k,i)
	end do
	return
	end
	subroutine wrte (nsz,dauer,z)
	implicit none
	integer nsz,k
	real*8 dauer
	real w,z(nsz)
	w=999999.
	open (unit=1,file='M_Werte',status='NEW')
	write(1,'(''	Zeit (in _s)	Helligkeit (in _M)'')')
	do k=1,nsz
	if(abs(w-z(k)).gt..001) then
		w=z(k)
		write(1,'(''	'',f12.1,''	'',f12.3)')
     +		float(k-1)*dauer/float(nsz-1),z(k)
	end if
	end do
	close (unit=1)
	return
	end
	real*8 function aa(n,k,radial,p,v,m,a)
	implicit none
	integer k,n
	real*8 a,ur,u2,radial(3),p(9,3),v(9,3),m(9,10)
	ur=radial(1)*p(k,1)+radial(2)*p(k,2)+radial(3)*p(k,3)
	u2=p(k,1)**2+p(k,2)**2+p(k,3)**2-ur*ur
	ur=a+ur
	aa=dsqrt(ur*ur+u2)
	return
	end
	real*8 function vv(n,k,radial,v,m,fak)
	implicit none
	integer k,n
	real*8 ur,u2,radial(3),v(9,3),m(9,10),fak
	ur=radial(1)*v(k,1)+radial(2)*v(k,2)+radial(3)*v(k,3)
	u2=v(k,1)**2+v(k,2)**2+v(k,3)**2-ur*ur
	ur=m(k,10)+ur*fak
	vv=dsqrt(ur*ur-u2)
	return
	end
	subroutine berechne(n,dauer,dt,a,m,nsz,s,z,
     +		radial,tangent,kreuz)
	implicit none
	logical logu,logo,lplt,initgrph
	character*1 txt(4)
	character*4 xtx
	character*80 zeile
	equivalence (txt(1),xtx)
	character*1 inkey,ink,cull
	integer*4 drin,draus,bereich
	integer i,j,k,n,nsz,err
	real xu,yu,xo,yo,fxx,fyy,xoo,yoo,dx,dy
	real*8 a,c,d,dauer,dt,t,tu,to,ur,vr,vmin,vmax,va,vn,vv,aa,ad
	real*8 fx,fy,xi,yi,xa,ya
	real*8 radial(3),tangent(3),kreuz(3)
	real*8 m(9,10)
	real z(nsz),s(nsz)
	real x(9)
	real y(9)
	real xx(9)
	real yy(9)
	real*8 mm(9)
	real*8 ll(9)
	real*8 p(9,3)
	real*8 q(9,3)
	real*8 p0(9,3)
	real*8 v(9,3)
	real*8 v0(9,3)
	real*8 w(9,3)
	real*8 b(9,3)
	data c/2.99792458D8/		! m_/_s 300000_km/_s
	write(*,*) ' deltas ',dauer/dt
	logu=.true.
	logo=.true.
	do k=1,n
	mm(k)=m(k,1)
	ll(k)=.1*dfloat(nsz)*(dt/dauer)*
     +		(1.d1)**(-.4*m(k,2))*(3.085678d17/a)**2
	do i=1,3
	p(k,i)=m(k,i+2)
	q(k,i)=p(k,i)
	v(k,i)=m(k,i+5)
	w(k,i)=v(k,i)
	end do
	end do
	call inivgl(n,3,p,v,p0,v0)
	tu=0.
	to=dauer
	vmin=9999.*c
	vmax=c/9999.
	do while (logu.or.logo)
	 logu=.false.
	 logo=.false.
******************
*	 Aufwrts
	 t=0.
*	 write(*,*) t,tu,to, ' Aufwrts'
	 do k=1,n
	  do i=1,3
	   p(k,i)=q(k,i)		! q Starter
	   v(k,i)=w(k,i)		! w Starter
	  end do
	 end do
	 do while(t.lt.to)
	  do k=1,n
	   do i=1,3
	    m(k,i+2)=p(k,i)
	   end do
	  end do
	  call gravitab(n,m,b)
	  do k=1,n
	   vr=dabs(dsqrt(v(k,1)**2+v(k,2)**2+v(k,3)**2))
	   call ausdrck(n,k,b,p,v,dt)
	   vn=dabs(dsqrt(v(k,1)**2+v(k,2)**2+v(k,3)**2))
	   if(vr.gt.vn) then
		va=vr
		vr=vn
		vn=va
	   end if
	   if(vr.gt..01) then
	    if(t.gt.tu.and.vn/vr.gt.1.2d0) then
		write(*,*) ' dt um',
     +		vr/vn,' zu gro  Taste ( x => Stop )'
		read (*,'(a1)') ink
		if(ink.eq.'x') stop
	    end if
	   end if
	   vr=vv(n,k,radial,v,m,1.d0)
	   if(vmin.gt.vr) vmin=vr
	   if(vmax.lt.vr) vmax=vr
	  end do
	  t=t+dt
	 end do
	 do k=1,n
	  ad=aa(n,k,radial,p,v,m,a)
	  if(ad/vmin-ad/m(k,10)+dauer.gt.to+dt) then
		logo=.true.
		to=ad/vmin-ad/m(k,10)+dauer
	  end if
	  if(ad/vmax-ad/m(k,10).lt.tu-dt) then
		logu=.true.
		tu=ad/vmax-ad/m(k,10)
	  end if
	 end do
*************
*	 Abwrts
	 t=0.
	 do k=1,n
	  do i=1,3
	   p(k,i)=q(k,i)		! q Starter
	   v(k,i)=w(k,i)		! w Starter
	  end do
	 end do
*	 write(*,*) t,tu,to, ' Abwrts'
	 do while(t.gt.tu)
	  do k=1,n
	   do i=1,3
	    m(k,i+2)=p(k,i)
	   end do
	  end do
	  call gravitab(n,m,b)
	  do k=1,n
	   vr=dabs(dsqrt(v(k,1)**2+v(k,2)**2+v(k,3)**2))
	   call ausdrck(n,k,b,p,v,-dt)
	   vn=dabs(dsqrt(v(k,1)**2+v(k,2)**2+v(k,3)**2))
	   if(vr.gt.vn) then
		va=vr
		vr=vn
		vn=va
	   end if
	   if(vr.gt..01) then
	    if(t.gt.tu.and.vn/vr.gt.1.2d0) then
		write(*,*) ' dt um',
     +		vn/vr,' zu gro  Taste ( x => Stop )'
		read (*,'(a1)') ink
		if(ink.eq.'x') stop
	    end if
	   end if
	   vr=vv(n,k,radial,v,m,-1.d0)
	   if(vmin.gt.vr) vmin=vr
	   if(vmax.lt.vr) vmax=vr
	  end do
	  t=t-dt
	 end do
	 do k=1,n
	  ad=aa(n,k,radial,p,v,m,a)
	  if(ad/vmin-ad/m(k,10)+dauer.gt.to+dt) then
		logo=.true.
		to=ad/vmin-ad/m(k,10)+dauer
	  end if
	  if(ad/vmax-ad/m(k,10).lt.tu-dt) then
		logu=.true.
		tu=ad/vmax-ad/m(k,10)
	  end if
	 end do
	 if(logu) then
	  bereich=-tu/dt
	  tu=-bereich*dt
	 end if
	 if(logo) then
	  bereich=to/dt
	  to=bereich*dt
	  do while(to.lt.dauer+dt) 
		to=to+dt
	  end do
	 end if
	end do
*	sichere Startwerte p,v bei t=tu , aufsteigend
	do k=1,n
	 do i=1,3
	  q(k,i)=p(k,i)
	  w(k,i)=v(k,i)
	 end do
	end do
	xi=1d90
	yi=xi
	xa=-xi
	ya=xa
	t=tu
	write(*,*) vmin-c,vmax-c,' _m/_s'
	write(*,*) tu,to
	do while(t.lt.to)
	 if(dabs(t).lt..1*dt) call vglpv (n,3,p,v,p0,v0)
	 do k=1,n
	  do i=1,3
	   m(k,i+2)=p(k,i)
	  end do
	 end do
	 call gravitab(n,m,b)
	 do k=1,n
	  vr=dabs(dsqrt(v(k,1)**2+v(k,2)**2+v(k,3)**2))+1.d-9
	  call ausdrck(n,k,b,p,v,dt)
	  vn=dabs(dsqrt(v(k,1)**2+v(k,2)**2+v(k,3)**2))+1.d-9
	  if(vr.gt.vn) then
		va=vr
		vr=vn
		vn=va
	  end if
	  if(vr.gt..01) then
	   if(t.gt.tu.and.vn/vr.gt.1.2d0) then
		write(*,*) ' dt um',
     +		vn/vr,' zu gro  Taste ( x => Stop )'
		read (*,'(a1)') ink
		if(ink.eq.'x') stop
	   end if
	  end if
	xx(k)=tangent(1)*p(k,1)+tangent(2)*p(k,2)+tangent(3)*p(k,3)
	yy(k)=kreuz(1)*p(k,1)+kreuz(2)*p(k,2)+kreuz(3)*p(k,3)
	  if(xi.gt.xx(k)) xi=xx(k)
	  if(yi.gt.yy(k)) yi=yy(k)
	  if(xa.lt.xx(k)) xa=xx(k)
	  if(ya.lt.yy(k)) ya=yy(k)
	 end do
	 t=t+dt
	end do
	d=.1*(xa-xi)
	xi=xi-d
	xa=xa+d
	d=.1*(ya-yi)
	yi=yi-d
	ya=ya+d
	xu=0.
	yu=0.
	xo=639.
	yo=424.
	fx=(xo-xu)/(xa-xi)
	fy=(yo-yu)/(ya-yi)
	do i=1,nsz
	z(i)=0.
	end do
	write(*,*) xu,yu,xo,yo
	write(*,*) ' Taste ( p => plt , x => Stop )'
	read (*,'(a1)') ink
	if(ink.eq.'x') stop
	lplt=(ink.eq.'p')
	if(xu.ge.xo.or.yu.ge.yo) stop ' xu>xo or yu>yo'
	if(.not.initgrph( 0, 0, 640, 425 )) stop 'fenster zu gross'
	call fenster(.true.,xu,yu,xo,yo)
*	write(*,*) ' nach fenster ',xu,yu,xo,yo,lplt
	if(lplt) call pltonoff ('kurve.plt')
*	write(*,*) ' nach pltonoff ##### '
	dx=.01*(xo-xu)
	dy=.01*(yo-yu)
	do k=1,n
	do i=1,3
	p(k,i)=q(k,i)		! Startwerte bei t=tu
	v(k,i)=w(k,i)
	end do
	end do
	drin=0
	draus=0
	t=tu
	do while(t.le.to)
	 do k=1,n
	  do i=1,3
	   m(k,i+2)=p(k,i)
	  end do
	  x(k)=tangent(1)*p(k,1)+tangent(2)*p(k,2)+tangent(3)*p(k,3)
	  x(k)=fx*(x(k)-xi)
	  y(k)=fy*(kreuz(1)*p(k,1)+kreuz(2)*p(k,2)+kreuz(3)*p(k,3)-yi)
	 end do
	 call gravitab(n,m,b)
	 do k=1,n
	  vr=vv(n,k,radial,v,m,1.d0)
	  call ausdrck(n,k,b,p,v,dt)
	  xx(k)=tangent(1)*p(k,1)+tangent(2)*p(k,2)+tangent(3)*p(k,3)
	  xx(k)=fx*(xx(k)-xi)
	  yy(k)=fy*(kreuz(1)*p(k,1)+kreuz(2)*p(k,2)+kreuz(3)*p(k,3)-yi)
	  if(lplt) then
		call farbe (15+(n-k)*1000)
		call strecke(x(k),y(k),xx(k),yy(k))
	  else
*		call farbe (15)
	  	call linie(x(k),y(k),xx(k),yy(k),15,0)
	  end if
	  if(t.le.0..and.t+dt.gt.0.) then
		call farbe (2)
		do i=-5,5
	call strecke(x(k)+.1*i*dx,y(k)+dy,x(k)-.1*i*dx,y(k)-dy)
	call strecke(x(k)-dx,y(k)+.1*i*dy,x(k)+dx,y(k)-.1*i*dy)
		end do
		call farbe (15)
	  else if(t.le.dauer.and.t+dt.gt.dauer) then
		call farbe (12)
		do i=-5,5
	call strecke(x(k)+.1*i*dx,y(k)+dy,x(k)-.1*i*dx,y(k)-dy)
	call strecke(x(k)-dx,y(k)+.1*i*dy,x(k)+dx,y(k)-.1*i*dy)
		end do
		call farbe (15)
	  end if
	  x(k)=xx(k)
	  y(k)=yy(k)
	  ur=vv(n,k,radial,v,m,1.d0)
	  ad=aa(n,k,radial,p,v,m,a)
	  if(vr.gt.0d0.and.ur.gt.0.d0) then
	   do i=0,9
	    d=(dfloat(9-i)*vr+dfloat(i)*ur)/9.
	    j=int(dfloat(nsz)*(t+.1*dt*dfloat(i)+.05*dt+ad/d-ad/c)/dauer)
	    if(j.gt.0.and.j.le.nsz) then
		z(j)=z(j)+ll(k)*d/c		! *d/c ist neu
		drin=drin+1
	    else
		draus=draus+1
	    end if
	   end do
	  else
		write(*,*) ' extreme Beschleunigung'
	  end if
	 end do
	 t=t+dt
	end do
	if(lplt) call pltonoff (' ')
*	call posixy()
	call textaus(1,' Taste ( w => write M_Werte )'//cull())
	if(inkey().eq.'w') logu=.true.
	if(drin.lt.100*nsz) then
		write(*,*) ' dt um ',100.*nsz/drin,
     +		' zu gro fr Helligkeitskurve'
		goto 1
	end if
	zeile=' '
	write(zeile,
     +	'('' Punkte in '',i9,'' aus '',i9,'' Taste ( x => Stop )'')')
     +	drin,draus
	call textaus(2,zeile(1:54)//cull())
	if(inkey().eq.'x') stop
	do i=1,nsz
	if(z(i).le.0.) then
		z(i)=0.
		do j=1,k
		z(i)=z(i)+.001*ll(j)		! Ausreier
		end do
	end if
	if(z(i).gt.0.) z(i)=-2.5*log10(z(i))
	end do
	if(logu) call wrte (nsz,dauer,z)
	xu=0.
	yu=1e9
	xo=float(nsz-1)
	yo=-yu
	do i=2,nsz-1
	if(z(i).lt.yu) yu=z(i)
	if(z(i).gt.yo) yo=z(i)
	if(s(i).gt.-900.) then
		if(s(i).lt.yu) yu=s(i)
		if(s(i).gt.yo) yo=s(i)
	end if
	end do
	fyy=.05*(yo-yu)
	yu=yu-fyy
	yo=yo+fyy
	fxx=639./xo
	if(yo.le.yu+.01) then
*		call posixy()
	 call textaus(2,' keine messbare Helligkeitsnderung!'//cull())
		goto 1
	end if
	fyy=424./(yo-yu)
	xoo=639.
	yoo=424.
	call fenster(.false.,0.,0.,xoo,yoo)
	if(lplt) call pltonoff ('magnitd.plt')
*	call posixy()
	zeile=' '
	write(zeile,
     + '(f9.2,'' _M '',f9.2,'' _M ,faky '',f9.4,
     + '' Taste ( x => Stop )'')') yu,yo,fyy
	call textaus(2,zeile(1:61)//cull())
	if(inkey().eq.'x') stop
	call farbe (2)
	do i=-999,999
	if(.1*float(i).gt.yu.and..1*float(i).lt.yo) then
	if(i.eq.10*(i/10)) then
		call farbe (2)
	write(xtx,'(i4)') i/10
	call textpkta ( .002*xoo,fyy*(yo-(.1*float(i)+.01*(yo-yu))),
     +			.01*xoo,0.,4,txt )
	else
		call farbe (1)
	end if
	call strecke(.05*xoo,fyy*(yo-.1*float(i)),
     +			xoo,fyy*(yo-.1*float(i)))
	end if
	end do
	if(.not.lplt) call farbe (15)
	if(lplt) call farbe (2015)
	do i=3,nsz-1
	call strecke(fxx*float(i-1),fyy*(yo-z(i-1)),
     +		fxx*float(i),fyy*(yo-z(i)))
	if(s(i-1).gt.-900..and.s(i).gt.-900.) then
		if(.not.lplt) call farbe (12)
		if(lplt) call farbe (1012)
		call strecke(fxx*float(i-1),fyy*(yo-s(i-1)),
     +			fxx*float(i),fyy*(yo-s(i)))
		call farbe (15)
	end if
	end do
	if(lplt) call pltonoff (' ')
1	continue
	if(inkey().eq.'x') stop
	call endgrphc()
	return
	end
	subroutine linie(x1,y1,x2,y2,f,g)
	implicit none
	real x1,y1,x2,y2,dx,dy,a
	integer i,f,g
	if(x1.eq.x2.and.y1.eq.y2) return
	call farbe (g)
	dx=y2-y1
	dy=x1-x2
	a=sqrt(dx*dx+dy*dy)
	dx=dx/a
	dy=dy/a
	do i=-2,2
	if(i.ne.0) call strecke(x1+float(i)*dx,y1+float(i)*dy,
     +			x2+float(i)*dx,y2+float(i)*dy)
	end do
	call farbe (f)
	call strecke(x1,y1,x2,y2)
	return
	end
	subroutine gravitab(n,m,w)
	implicit none
	character*1 ink
	integer i,j,k,n
	real*8 gc,r,v(3),m(9,10),w(9,3)
	data gc/6.67259d-11/
	do i=1,n
	 do j=1,3
	  w(i,j)=0.        !*(_m/(_s)**2)
	 end do
	end do
	do i=1,n-1
	 do k=i+1,n
	  do j=3,5
	   v(j-2)=m(i,j)-m(k,j)
	  end do
	  r=0.             !*_m**2
	  do j=1,3
	   r=r+v(j)**2
	  end do
	  r=dsqrt(r)
	  if(r+r.lt.m(i,9)+m(k,9)) then
		write(*,*) ' Kollision von',i,k,' Taste ( x => Stop )'
		read (*,'(a1)') ink
		if(ink.eq.'x') stop
	  end if
	  do j=1,3
	   v(j)=v(j)/r
	  end do
	  do j=1,3
	   v(j)=gc*m(i,1)*m(k,1)*v(j)/r**2
	  end do
	  do j=1,3
	   w(i,j)=w(i,j)-v(j)/(m(i,1))
	   w(k,j)=w(k,j)+v(j)/(m(k,1))
	  end do
	 end do
	end do
	return
	end
	real*8 function inzl(zeile,u,o)
	implicit none
	character*80 zeile
	character*8 form
	integer u,o
	real*8 w
	inzl=0.
	do while(u.lt.o.and.(zeile(u:u).eq.' '.or.zeile(u:u).eq.'	'))
	u=u+1
	end do
	if(u.gt.o) stop ' Eingabefehler leere Zeichenkette'
	if(o-u.lt.9) then
		write(form,'(''(f'',i1,''.0)'')') o-u+1
	else
		write(form,'(''(f'',i2,''.0)'')') o-u+1
	end if
*	write(*,*) form
*	write(*,*) zeile(u:o)
	read (zeile(u:o),form,err=1) w
	inzl=w
	return
1	continue
	write(*,*) ' Eingabefehler bei ',zeile(u:o)
	stop
	end
	subroutine next(zeile,u,o)
	implicit none
	character*80 zeile
	integer u,o
	do while(u.lt.80.and.zeile(u:u).eq.' '.or.
     +		 zeile(u:u).eq.'	')
	u=u+1
	end do
	o=u+1
	do while(o.lt.80.and.zeile(o:o).ne.' '.and.
     +		 zeile(o:o).ne.'	')
	o=o+1
	end do
	o=o-1
	if(o.gt.80) o=80
	u=u-1				! #####
	if(u.lt.1) u=1
	return
	end
	subroutine zlin(zeile,u,o)
	implicit none
	character*80 zeile
	integer u,o
	o=80
	do while(o.gt.1.and.zeile(o:o).eq.' ')
	o=o-1
	end do
	u=1
	do while(u.lt.o.and.zeile(u:u).eq.' '.or.
     +		 zeile(u:u).eq.'	')
	u=u+1
	end do
	u=u-1				! #####
	if(u.lt.1) u=1
	return
	end
	real*8 function abstand(zeile,u,o)
	implicit none
	character*80 zeile
	integer u,o
	real*8 a,inzl
	a=0.
	if(zeile(o-4:o).eq.'_ltyr') then
		a=inzl(zeile,u,o-5)*9.4605284048794d15
	else if(zeile(o-2:o).eq.'_pc') then
		a=inzl(zeile,u,o-3)*3.085678d16
	else if(zeile(o-2:o).eq.'_au') then
		a=inzl(zeile,u,o-3)*149597900000.
	else if(zeile(o-2:o).eq.'_km') then
		a=inzl(zeile,u,o-3)*1000.
	else if(zeile(o-1:o).eq.'_m') then
		a=inzl(zeile,u,o-2)
	else
		a=inzl(zeile,u,o)
	end if
	abstand=a
	return
	end
	real*8 function zeit(zeile,u,o)
	implicit none
	character*80 zeile
	integer u,o
	real*8 z,inzl
	call zlin(zeile,u,o)
	z=0.
	if(zeile(o-3:o).eq.'_day') then
		z=inzl(zeile,u,o-4)*86400.
	else if(zeile(o-3:o).eq.'_min') then
		z=inzl(zeile,u,o-4)*60.
	else if(zeile(o-2:o).eq.'_hr') then
		z=inzl(zeile,u,o-3)*3600.
	else if(zeile(o-2:o).eq.'_yr') then
		z=inzl(zeile,u,o-3)*31556925.9747
	else if(zeile(o-1:o).eq.'_s') then
		z=inzl(zeile,u,o-2)
	else
		z=inzl(zeile,u,o)
	end if
	zeit=z
	return
	end
	subroutine beispiel ()
	implicit none
	character*1 ink
	write(*,*) ' Eingabedatei ballist.dat fehlt.'
	write(*,*) ' Es wird eine Beispieldatei erzeugt.'
	write(*,*) ' In ihr sind vier Beispiele enthalten.'
	write(*,*) ' Sie erklren sich selbst und knnen'
	write(*,*) ' sinngem abgendert werden.'
	write(*,*) ' Es wird immer das erste Beispiel gerechnet.'
	write(*,*) ' Taste ( x => Stop )'
	read (*,'(a1)') ink
	if(ink.eq.'x') stop
	open (unit=1,file='ballist.dat',status='NEW')
	write(1,'('' Radial'')')
	write(1,'('' 0	0	1'')')
	write(1,'('' Tangential'')')
	write(1,'('' 1	0	0'')')
	write(1,'('' Anzahl Koerper Werte'')')
	write(1,'(''	2	1000'')')
	write(1,'('' dt				Standard _s'')')
	write(1,'('' 20_min'')')
	write(1,'('' Dauer			Standard _s'')')
	write(1,'('' 464_day'')')
	write(1,'('' Abstand		Standard _m'')')
	write(1,'('' 50_pc'')')
	write(1,'('' Massen			Standard _kg'')')
	write(1,'('' 4d31_kg	9d30_kg'')')
	write(1,'('' Helligkeiten		Standard _M'')')
	write(1,'('' .71_M		4.8_M'')')
	write(1,'('' Durchmesser		Standard _m'')')
	write(1,'('' 3d6_km		1.4d6_km'')')
	write(1,'('' Positionen		Standard _m'')')
	write(1,'('' -.5_au	0_m	0_m'')')
	write(1,'('' 1_au	0_m	0_m'')')
	write(1,'('' Geschwindigkeiten	Standard _m/_s'')')
	write(1,'('' 0_m/_s	-10000_m/_s	100_m/_s'')')
	write(1,'('' 0_m/_s	29800_m/_s	-250_m/_s'')')
	write(1,'('' '')')
	write(1,'('' Beispiel Erde/Sonne:'')')
	write(1,'('' --------------------'')')
	write(1,'('' Radial'')')
	write(1,'('' 0	0	1'')')
	write(1,'('' Tangential'')')
	write(1,'('' 1	0	0'')')
	write(1,'('' Anzahl Koerper	Werte'')')
	write(1,'('' 	2	1000'')')
	write(1,'('' dt				Standard _s'')')
	write(1,'('' 10_min'')')
	write(1,'('' Dauer			Standard _s'')')
	write(1,'('' 366_day'')')
	write(1,'('' Abstand		Standard _m'')')
	write(1,'('' 10_pc'')')
	write(1,'('' Massen			Standard _kg'')')
	write(1,'('' 1.99d30_kg	5.975d24_kg'')')
	write(1,'('' Helligkeiten		Standard _M'')')
	write(1,'('' 4.71_M		40_M'')')
	write(1,'('' Durchmesser		Standard _m'')')
	write(1,'('' 1.392d6_km		12750_km'')')
	write(1,'('' Positionen		Standard _m'')')
	write(1,'('' 0_m	0_m	0_m'')')
	write(1,'('' 1_au	0_m	0_m'')')
	write(1,'('' Geschwindigkeiten	Standard _m/_s'')')
	write(1,'('' 0_m/_s	0_m/_s	0_m/_s'')')
	write(1,'('' 0_m/_s	29800_m/_s	0_m/_s'')')
	write(1,'('' '')')
	write(1,'('' Beispiel mit 3 Komponenten:'')')
	write(1,'('' ---------------------------'')')
	write(1,'('' Radial'')')
	write(1,'('' 0	0	1'')')
	write(1,'('' Tangential'')')
	write(1,'('' 1	0	0'')')
	write(1,'('' Anzahl Koerper Werte'')')
	write(1,'(''	3	1000'')')
	write(1,'('' dt				Standard _s'')')
	write(1,'('' 10_min'')')
	write(1,'('' Dauer			Standard _s'')')
	write(1,'('' 464_day'')')
	write(1,'('' Abstand		Standard _m'')')
	write(1,'('' 50_pc'')')
	write(1,'('' Massen			Standard _kg'')')
	write(1,'('' 4d31_kg	9d30_kg	5d29_kg'')')
	write(1,'('' Helligkeiten		Standard _M'')')
	write(1,'('' .71_M	4.8_M	6.3_M'')')
	write(1,'('' Durchmesser'')')
	write(1,'('' 3d6_km	1.4d6_km	9d5_km'')')
	write(1,'('' Positionen		Standard _m'')')
	write(1,'('' -.5_au	0_m	0_m'')')
	write(1,'('' 1_au	0_m	0_m'')')
	write(1,'('' .5_au	.5_au	1.5_au'')')
	write(1,'('' Geschwindigkeiten	Standard _m/_s'')')
	write(1,'('' 0_m/_s	-10_km/_s	100_m/_s'')')
	write(1,'('' 0_m/_s	29.8_km/_s	-250_m/_s'')')
	write(1,'('' -50_km/_s	0_m/_s	-5_km/_s'')')
	write(1,'('' '')')
	write(1,'('' Beispiel Bedeckungsveraenderliche ?'')')
	write(1,'('' -----------------------------------'')')
	write(1,'('' Radial'')')
	write(1,'(''  0.223694374 -0.0405558916  0.973815202'')')
	write(1,'('' Tangential'')')
	write(1,'(''  0.00907959483  0.999177271  0.0395264633'')')
	write(1,'('' Anzahl Koerper Werte'')')
	write(1,'('' 2 2000'')')
	write(1,'('' dt                         Standard _s'')')
	write(1,'(''  3000.'')')
	write(1,'('' Dauer                      Standard _s'')')
	write(1,'(''  220000000.'')')
	write(1,'('' Abstand            Standard _m'')')
	write(1,'(''  1.17503073E+18'')')
	write(1,'('' Massen                     Standard _kg'')')
	write(1,'(''  2.50947096E+31  2.62605592E+31'')')
	write(1,'('' Helligkeiten               Standard _M'')')
	write(1,'(''  2.19427734  30.662793'')')
	write(1,'('' Durchmesser                Standard _m'')')
	write(1,'(''  3.E+09  1.4E+09'')')
	write(1,'('' Positionen         Standard _m'')')
	write(1,'('' -1.16106354E+11  2.9628397E+10 -6.26923025E+09'')')
	write(1,'(''  1.55004312E+11 -1.49623646E+11  873252620.'')')
	write(1,'('' Geschwindigkeiten  Standard _m/_s'')')
	write(1,'(''  13992.8592 -44589.0403  32997.675'')')
	write(1,'('' -41272.943  63015.358  7859.55457'')')
	write(1,'('' '')')
	write(1,'('' Um den Helligkeitsverlauf genauer zu sehen,'')')
	write(1,'('' verkleinere dt und Dauer auf ein zehntel'')')
	write(1,'('' der oben angegebenen Werte.'')')
	write(1,'('' '')')
	close(unit=1)
	open (unit=1,file='ballist.dat',status='OLD')
	return
	end
	subroutine eingabe(n,dauer,dt,a,m,nsz)
	implicit none
	character*80 zeile
	integer i,k,n,u,o,nsz
	real*8 m(9,10)
	real*8 dt,a,dauer,inzl,abstand,zeit,dglzeit
	open(unit=1,file='ballist.dat',status='OLD')
	do i=1,4
	read (1,*)
	end do
	read (1,'(a)') zeile
	write(*,*) zeile
	read (1,*) n,nsz
	write(*,*) n,nsz
	zeile=' '
	read (1,'(a)') zeile
	write(*,*) zeile
	read (1,'(a)') zeile
	write(*,*) zeile
	call zlin(zeile,u,o)
	dt=zeit(zeile,u,o)
	write(*,*) ' dt=',dt
	if(dt.le.0.) stop 'dt'
	zeile=' '
	read (1,'(a)') zeile
	read (1,'(a)') zeile
	call zlin(zeile,u,o)
	dauer=zeit(zeile,u,o)
	zeile=' '
	read (1,*)
	read (1,'(a)') zeile
	call zlin(zeile,u,o)
	a=abstand(zeile,u,o)
	write(*,*) ' a=',a
	zeile=' '
	read (1,*)
	read (1,'(a)') zeile
	u=1
	do k=1,n
	call next(zeile,u,o)
	m(k,1)=0.
	if(zeile(o-2:o).eq.'_kg') then
		m(k,1)=inzl(zeile,u,o-3)
	else if(zeile(o-1:o).eq.'_g') then
		m(k,1)=inzl(zeile,u,o-2)*.001
	else
		m(k,1)=inzl(zeile,u,o)
	end if
	u=o+1
	end do
	zeile=' '
	read (1,*)
	read (1,'(a)') zeile
	u=1
	do k=1,n
	call next(zeile,u,o)
	m(k,2)=0.
	if(zeile(o-1:o).eq.'_M') then
		m(k,2)=inzl(zeile,u,o-2)
	else
		m(k,2)=inzl(zeile,u,o)
	end if
	u=o+1
	end do
	zeile=' '
	read (1,*)
	read (1,'(a)') zeile
	u=1
	do k=1,n
	call next(zeile,u,o)
	m(k,9)=abstand(zeile,u,o)/2.d0
	u=o+1
	end do
	do k=1,n
*	v=Abstand/dglzeit(Radius,Masse,Abstand,Index)
	m(k,10)=a/dglzeit(m(k,9),m(k,1),a,k)
	end do
	read (1,*)
	do k=1,n
	zeile=' '
	read (1,'(a)') zeile
	u=1
	do i=3,5
	call next(zeile,u,o)
	m(k,i)=abstand(zeile,u,o)
	u=o+1
	end do
	end do
	read (1,*)
	do k=1,n
	zeile=' '
	read (1,'(a)') zeile
	u=1
	do i=6,8
	call next(zeile,u,o)
	m(k,i)=0.
	if(zeile(o-5:o).eq.'_km/_s') then
		m(k,i)=inzl(zeile,u,o-6)*1000.
	else if(zeile(o-4:o).eq.'_m/_s') then
		m(k,i)=inzl(zeile,u,o-5)
	else
		m(k,i)=inzl(zeile,u,o)
	end if
	u=o+1
	end do
	end do
	zeile=' '
	read (1,'(a)') zeile
	u=1
	do while(u.lt.80.and.zeile(u:u).ne.'(')
	u=u+1
	end do
	o=u+1
	do while(o.lt.80.and.zeile(o:o).ne.')')
	o=o+1
	end do
	if(u.gt.1.and.o.lt.80) then
*	read (1,zeile(u:o)) (s(k),k=1,nsz)
	end if
	close (unit=1)
	return
	end
	subroutine magnitud(dauer,nsz,s)
	implicit none
	integer i,j,k,nsz,err,nwx
	real*8 x(200)
	real*8 y(200)
	real s(nsz)
	real*8 dauer,v,w
	do k=1,nsz
	s(k)=-9999.
	end do
	open (unit=1,file='magnitud.dat',status='OLD',err=1)
	read (1,*)
	read (1,*) j
	if(j.gt.200) stop ' mehr als 200 M_Werte'
	if(j.lt.2) goto 1
	read (1,*)
	read (1,*) (x(k),k=1,j)
	read (1,*)
	read (1,*) (y(k),k=1,j)
	do k=2,j
	if(max(1,nwx(x(k-1),dauer,nsz)).lt.
     +		min(nsz,nwx(x(k),dauer,nsz))) then
		do i=max(1,nwx(x(k-1),dauer,nsz)),
     +		     min(nsz,nwx(x(k),dauer,nsz))
		v=dfloat(nwx(x(k),dauer,nsz)-i)
		w=dfloat(i-nwx(x(k-1),dauer,nsz))
		s(i)=(y(k-1)*v+y(k)*w)/
     +		      dfloat(nwx(x(k),dauer,nsz)-nwx(x(k-1),dauer,nsz))
		end do
	end if
	end do
1	continue
	close (unit=1)
	return
	end
	integer function nwx(x,dauer,nsz)
	implicit none
	real*8 x,dauer
	integer nsz
	nwx=int(x*float(nsz-1)/dauer)+1
	return
	end
	real*8 function dglzeit(r,m,s,k)
	implicit none
	character*1 ink
	real*8 r,m,s,a,b,c,d,dt,gc,t
	integer k,n
*	r m s (in _m _kg _m)
*	z.B.:r=7E8 m=1.99E30 s=3.085678E17
	data c/299792458./
	data gc/6.67259d-11/
*********
*	r Radius in _m
*	m Masse  in _kg
*	s Weg    in _m
*	t Zeit   in _s
*	v Geschwindigkeit in _m/_s
*	b Beschleunigung  in _m/(_s)^2
*	Relationen: *b(t)=gc*m/s(t)^2
*	v'(t)=b(t) and v(0)=c
*	s'(t)=v(t) and s(0)=r ,d.h.
*	s''(t)=-gc*m/(s(t))^2
*	numerische Lsung:
*	a Abstand, b Geschwindigkeit, t Zeit
*	mittlere Beschleunigung:
*	m*(gc/(a)-gc/(a+d))/d
*********
	n=10000
	dt=1.
	t=0.
	a=r
	b=c
	d=dt*b
	do while(dt*m*(gc/a-gc/(a+d))/(d*b).gt..00001)
	d=d/2
	dt=dt/2
	n=n-1
	if(n.eq.999) then
	write(*,*) 'r',k,' ziemlich klein	Taste ( x => Stop )'
	read (*,'(a1)') ink
	if(ink.eq.'x') stop
	end if
	end do
	do while(a+d.lt.s)
	a=a+b*dt
	t=t+dt
	b=b+dt*m*(gc/(a+d)-gc/a)/d
	if(dt*m*(gc/a-gc/(a+d))/(d*b).lt..00001) then
	d=d+d
	dt=dt+dt
	end if
	n=n-1
	if(n.eq.9000) then
	write(*,*)
     +	'r',k,' zu klein um genau zu rechnen! Taste ( x => Stop )'
	read (*,'(a1)') ink
	if(ink.eq.'x') stop
	end if
	if(n.lt.0) stop ' r absolut zu klein!'
	end do
	t=t+dt*(s-a)/d
	dglzeit=t
	return
	end
